close all
clc
clear all
load Gunx
max_itr = 10;
M=4;
N=16;
T=50;
for rpt=1:10
    clear datat;
    for i=2:3:150
        datat(:,(i+1)/3)=(Gunx(:,i)+Gunx(:,i+1)+Gunx(:,i+2))/3;
    end        
    datat=quantize(datat,'levels',N,'method','kmeans');
    labels_data=Gunx(:,1);
    A=randperm(size(Gunx,1));
    data=datat(A',:);
    labels_data=labels_data(A');
    train_data=data(1:50,:);
    train_labels=labels_data(1:50,:);
    test_data=data(51:end,:);
    test_labels=labels_data(51:end,:);
    sz=size(train_data);      
    clear train_1;
    clear train_2;
    clear test_1;
    clear test_2;
    train_1(:,:)=train_data(find(train_labels==1),:);
    train_2(:,:)=train_data(find(train_labels==2),:);
    test_1(:,:)=test_data(find(test_labels==1),:);
    test_2(:,:)=test_data(find(test_labels==2),:);
    %           Rabiner
    prior1 = normalise(rand(M,1));
    transmat1 = mk_stochastic(rand(M,M));
    obsmat1 = mk_stochastic(rand(M,N));
    [LL_R_1, prior_R_1, transmat_R_1, obsmat_R_1] = dhmm_em(train_1, prior1, transmat1, obsmat1,'max_iter', 10, 'verbose', 0);
    prior2 = normalise(rand(M,1));
    transmat2 = mk_stochastic(rand(M,M));
    obsmat2 = mk_stochastic(rand(M,N));
    [LL_R_2, prior_R_2, transmat_R_2, obsmat_R_2] = dhmm_em(train_2, prior2, transmat2, obsmat2,'max_iter', 10, 'verbose', 0);
    trueRab=0;
    for j=1:size(test_1,1)
        log1(j)=dhmm_logprob(test_1(j,:), prior_R_1, transmat_R_1, obsmat_R_1);
    end
    for j=1:size(test_2,1)
        log2(j)=dhmm_logprob(test_2(j,:), prior_R_1, transmat_R_1, obsmat_R_1);
    end
    log1=sort(log1,'descend');
    log2=sort(log2,'descend');
    first=min( min(log1(find(isfinite(log1)))), min(log2(find(isfinite(log2)))));
    Tresh=(first*2:abs(first)/500:0);
    for Tr=Tresh
        TP_1=sum(find(log1>Tr,1,'last'));
        FP_1=sum(find(log2>Tr,1,'last'));
        ROC1(Tresh==Tr,:)=[Tr FP_1/size(test_2,1) TP_1/size(test_1,1)];
    end
    for j=1:size(test_1,1)
        log1(j)=dhmm_logprob(test_1(j,:), prior_R_2, transmat_R_2, obsmat_R_2);
    end
    for j=1:size(test_2,1)
        log2(j)=dhmm_logprob(test_2(j,:), prior_R_2, transmat_R_2, obsmat_R_2);
    end
    log1=sort(log1,'descend');
    log2=sort(log2,'descend');
    for Tr=Tresh
        TP_2=sum(find(log2>Tr,1,'last'));
        FP_2=sum(find(log1>Tr,1,'last'));
        ROC2(Tresh==Tr,:)=[Tr FP_2/size(test_1,1) TP_2/size(test_2,1)];
    end
    avg_logs(2,:,:)=[mean(log1) mean(log2)];
    AUC_rb=[-trapz(ROC1(:,2),ROC1(:,3)) -trapz(ROC2(:,2),ROC2(:,3))];
    AUC_Rabiner(rpt)=mean(AUC_rb);
    for j=1:size(test_1,1)
        log1=dhmm_logprob(test_1(j,:), prior_R_1, transmat_R_1, obsmat_R_1);
        log2=dhmm_logprob(test_1(j,:), prior_R_2, transmat_R_2, obsmat_R_2);
        if (log1>log2)
            trueRab=trueRab+1;
        end
    end
    for j=1:size(test_2,1)
        log1=dhmm_logprob(test_2(j,:), prior_R_1, transmat_R_1, obsmat_R_1);
        log2=dhmm_logprob(test_2(j,:), prior_R_2, transmat_R_2, obsmat_R_2);
        if (log2>log1)
            trueRab=trueRab+1;
        end
    end
    %           base HMMs
    for j=1:size(train_1,1)
        prior1 = normalise(rand(M,1));
        transmat1 = mk_stochastic(rand(M,M));
        obsmat1 = mk_stochastic(rand(M,N));
        [LL2, prior2, transmat2, obsmat2] = dhmm_em(train_1(j,:), prior1, transmat1, obsmat1,'max_iter', max_itr, 'verbose', 0);
        prior_1(:,j)=prior2;
        transmat_1(:,:,j)=transmat2;
        obsmat_1(:,:,j)=obsmat2;
        LL(j)=LL2(size(LL2, 2));
    end
    for j=1:size(train_2,1)
        prior1 = normalise(rand(M,1));
        transmat1 = mk_stochastic(rand(M,M));
        obsmat1 = mk_stochastic(rand(M,N));
        [LL2, prior2, transmat2, obsmat2] = dhmm_em(train_2(j,:), prior1, transmat1, obsmat1,'max_iter', max_itr, 'verbose', 0);
        prior_2(:,j)=prior2;
        transmat_2(:,:,j)=transmat2;
        obsmat_2(:,:,j)=obsmat2;
        LL(j)=LL2(size(LL2, 2));
    end
    %              (Ensemble)  Wk=1
    ens_prior1=zeros(M,1);
    ens_transmat1=zeros(M,M);
    ens_obsmat1=zeros(M,N);
    Na=size(train_1,1);
    for j=1:size(train_1,1)
        ens_prior1=ens_prior1+prior_1(:,j)/Na;
        ens_transmat1=ens_transmat1+transmat_1(:,:,j)/Na;
        ens_obsmat1=ens_obsmat1+obsmat_1(:,:,j)/Na;
    end
    ens_prior2=zeros(M,1);
    ens_transmat2=zeros(M,M);
    ens_obsmat2=zeros(M,N);
    Na=size(train_2,1);
    for j=1:size(train_2,1)
        ens_prior2=ens_prior2+prior_2(:,j)/Na;
        ens_transmat2=ens_transmat2+transmat_2(:,:,j)/Na;
        ens_obsmat2=ens_obsmat2+obsmat_2(:,:,j)/Na;
    end
    for j=1:size(test_1,1)
        log1(j)=dhmm_logprob(test_1(j,:), ens_prior1, ens_transmat1, ens_obsmat1);
    end
    for j=1:size(test_2,1)
        log2(j)=dhmm_logprob(test_2(j,:), ens_prior1, ens_transmat1, ens_obsmat1);
    end
    log1=sort(log1,'descend');
    log2=sort(log2,'descend');
    first=min( min(log1(find(isfinite(log1)))), min(log2(find(isfinite(log2)))));
    %Tresh=(first*2:abs(first)/500:0);
    for Tr=Tresh
        TP_1=sum(find(log1>Tr,1,'last'));
        FP_1=sum(find(log2>Tr,1,'last'));
        ROC1(Tresh==Tr,:)=[Tr FP_1/size(test_2,1) TP_1/size(test_1,1)];
    end
    for j=1:size(test_1,1)
        log1(j)=dhmm_logprob(test_1(j,:), ens_prior2, ens_transmat2, ens_obsmat2);
    end
    for j=1:size(test_2,1)
        log2(j)=dhmm_logprob(test_2(j,:), ens_prior2, ens_transmat2, ens_obsmat2);
    end
    log1=sort(log1,'descend');
    log2=sort(log2,'descend');
    for Tr=Tresh
        TP_2=sum(find(log2>Tr,1,'last'));
        FP_2=sum(find(log1>Tr,1,'last'));
        ROC2(Tresh==Tr,:)=[Tr FP_2/size(test_1,1) TP_2/size(test_2,1)];
    end
    avg_logs(2,:,:)=[mean(log1) mean(log2)];
    AUC_ens=[-trapz(ROC1(:,2),ROC1(:,3)) -trapz(ROC2(:,2),ROC2(:,3))];
    AUC_Ensemble(rpt)=mean(AUC_ens);
    trueEns=0;
    for j=1:size(test_1,1)
        log1=dhmm_logprob(test_1(j,:), ens_prior1, ens_transmat1, ens_obsmat1);
        log2=dhmm_logprob(test_1(j,:), ens_prior2, ens_transmat2, ens_obsmat2);
        if (log1>log2)
            trueEns=trueEns+1;
        end
    end
    for j=1:size(test_2,1)
        log1=dhmm_logprob(test_2(j,:), ens_prior1, ens_transmat1, ens_obsmat1);
        log2=dhmm_logprob(test_2(j,:), ens_prior2, ens_transmat2, ens_obsmat2);
        if (log2>log1)
            trueEns=trueEns+1;
        end
    end
    %                   alpha
    alpha_array = [-64 -32 -16 -8 -4 -3 -2 -1.7 -1.5 -1.4 -1.3 -1.2 -1.1 -1 -0.9 -0.8 -0.7 -0.6 -0.5 -0.4 -0.3 -0.2 -0.1 0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 1.1 1.2 1.3 1.4 1.5 1.7 2 3 4 8 16 32 64];
    for alpha=alpha_array
        trueAlpha=0;
        if(alpha<0)
            EPS=eps;
        else
            EPS=0;
        end
        ens_prior1=zeros(M,1);
        ens_transmat1=zeros(M,M);
        ens_obsmat1=zeros(M,N);
        for j=1:size(train_1,1)
            if(alpha==0)
                ens_prior1=min(ens_prior1,prior_1(:,j)+EPS);
                ens_transmat1=min(ens_transmat1,transmat_1(:,:,j)+EPS);
                ens_obsmat1=min(ens_obsmat1,obsmat_1(:,:,j)+EPS);
            else
                ens_prior1=ens_prior1+(prior_1(:,j)+EPS).^alpha;
                ens_transmat1=ens_transmat1+(transmat_1(:,:,j)+EPS).^alpha;
                ens_obsmat1=ens_obsmat1+(obsmat_1(:,:,j)+EPS).^alpha;
            end
        end
        if(alpha~=0)
            ens_prior1=ens_prior1.^(1/alpha);
            ens_transmat1=ens_transmat1.^(1/alpha);
            ens_obsmat1=ens_obsmat1.^(1/alpha);
        end
        ens_prior1=(ens_prior1-EPS)./sum(ens_prior1-EPS);
        sum_tran1=sum(ens_transmat1-EPS,2);
        sum_obs1=sum(ens_obsmat1-EPS,2);
        for i=1:M
            ens_transmat1(i,:)=(ens_transmat1(i,:)-EPS)./sum_tran1(i);
            ens_obsmat1(i,:)=(ens_obsmat1(i,:)-EPS)./sum_obs1(i);
        end
        ens_prior2=zeros(M,1);
        ens_transmat2=zeros(M,M);
        ens_obsmat2=zeros(M,N);
        for j=1:size(train_2,1)
            if(alpha==0)
                ens_prior2=min(ens_prior2,(prior_2(:,j)+EPS));
                ens_transmat2=min(ens_transmat2,(transmat_2(:,:,j)+EPS));
                ens_obsmat2=min(ens_obsmat2,(obsmat_2(:,:,j)+EPS));
            else
                ens_prior2=ens_prior2+(prior_2(:,j)+EPS).^alpha;
                ens_transmat2=ens_transmat2+(transmat_2(:,:,j)+EPS).^alpha;
                ens_obsmat2=ens_obsmat2+(obsmat_2(:,:,j)+EPS).^alpha;
            end
        end
        if(alpha~=0)
            ens_prior2=ens_prior2.^(1/alpha);
            ens_transmat2=ens_transmat2.^(1/alpha);
            ens_obsmat2=ens_obsmat2.^(1/alpha);
        end
        ens_prior2=(ens_prior2-EPS)./sum(ens_prior2-EPS);
        sum_tran2=sum(ens_transmat2-EPS,2);
        sum_obs2=sum(ens_obsmat2-EPS,2);
        for i=1:M
            ens_transmat2(i,:)=(ens_transmat2(i,:)-EPS)./sum_tran2(i);
            ens_obsmat2(i,:)=(ens_obsmat2(i,:)-EPS)./sum_obs2(i);
        end
        for j=1:size(test_1,1)
            log1(j)=dhmm_logprob(test_1(j,:), ens_prior1, ens_transmat1, ens_obsmat1);
        end
        for j=1:size(test_2,1)
            log2(j)=dhmm_logprob(test_2(j,:), ens_prior1, ens_transmat1, ens_obsmat1);
        end
        log1=sort(log1,'descend');
        log2=sort(log2,'descend');
        for Tr=Tresh
            TP_1=sum(find(log1>Tr,1,'last'));
            FP_1=sum(find(log2>Tr,1,'last'));
            ROC1(Tresh==Tr,:)=[Tr FP_1/size(test_2,1) TP_1/size(test_1,1)];
        end
        for j=1:size(test_1,1)
            log1(j)=dhmm_logprob(test_1(j,:), ens_prior2, ens_transmat2, ens_obsmat2);
        end
        for j=1:size(test_2,1)
            log2(j)=dhmm_logprob(test_2(j,:), ens_prior2, ens_transmat2, ens_obsmat2);
        end
        log1=sort(log1,'descend');
        log2=sort(log2,'descend');
        for Tr=Tresh
            TP_2=sum(find(log2>Tr,1,'last'));
            FP_2=sum(find(log1>Tr,1,'last'));
            ROC2(Tresh==Tr,:)=[Tr FP_2/size(test_1,1) TP_2/size(test_2,1)];
        end
        Percent_alpha(alpha==alpha_array,:)=[-trapz(ROC1(:,2),ROC1(:,3)) -trapz(ROC2(:,2),ROC2(:,3))];
        AUC_alpha(alpha==alpha_array,rpt)=mean(Percent_alpha(alpha==alpha_array));
        %           alpha with neg
        for ii=1:M
            [A,B]=sort(ens_obsmat1(ii,:));
            tmp=ens_obsmat1(ii,:);
            for i=1:N
                tmp1(ii,i)=tmp(B(N-find(B==i)+1));
            end
        end
        for ii=1:M
            [A,B]=sort(ens_obsmat2(ii,:));
            tmp=ens_obsmat2(ii,:);
            for i=1:N
                tmp2(ii,i)=tmp(B(N-find(B==i)+1));
            end
        end
        Obsmat_1=(tmp2+ens_obsmat1)/2;
        Obsmat_2=(tmp1+ens_obsmat2)/2;
        sum_obs1=sum(Obsmat_1,2);
        sum_obs2=sum(Obsmat_2,2);
        for i=1:M
            Obsmat_1(i,:)=(Obsmat_1(i,:)-EPS)./sum_obs1(i);
            Obsmat_2(i,:)=(Obsmat_2(i,:)-EPS)./sum_obs2(i);
        end
        for j=1:size(test_1,1)
            log1(j)=dhmm_logprob(test_1(j,:), ens_prior1, ens_transmat1, Obsmat_1);
        end
        for j=1:size(test_2,1)
            log2(j)=dhmm_logprob(test_2(j,:), ens_prior1, ens_transmat1, Obsmat_1);
        end
        log1=sort(log1,'descend');
        log2=sort(log2,'descend');
        for Tr=Tresh
            TP_1=sum(find(log1>Tr,1,'last'));
            FP_1=sum(find(log2>Tr,1,'last'));
            ROC1(Tresh==Tr,:)=[Tr FP_1/size(test_2,1) TP_1/size(test_1,1)];
        end
        for j=1:size(test_1,1)
            log1(j)=dhmm_logprob(test_1(j,:), ens_prior2, ens_transmat2, Obsmat_2);
        end
        for j=1:size(test_2,1)
            log2(j)=dhmm_logprob(test_2(j,:), ens_prior2, ens_transmat2, Obsmat_2);
        end
        log1=sort(log1,'descend');
        log2=sort(log2,'descend');
        for Tr=Tresh
            TP_2=sum(find(log2>Tr,1,'last'));
            FP_2=sum(find(log1>Tr,1,'last'));
            ROC2(Tresh==Tr,:)=[Tr FP_2/size(test_1,1) TP_2/size(test_2,1)];
        end
        Percent_alpha_Neg(alpha==alpha_array,:)=[-trapz(ROC1(:,2),ROC1(:,3)) -trapz(ROC2(:,2),ROC2(:,3))];
        AUC_alpha_Neg(alpha==alpha_array,rpt)=mean(Percent_alpha_Neg(alpha==alpha_array));
    end
end
mean(AUC_Rabiner)
mean(AUC_Ensemble)
mean(AUC_alpha,2)
mean(AUC_alpha_Neg,2)






